"""
    Quick plot of the dam break outputs

"""
import util
from matplotlib import pyplot as pyplot

p_st = util.get_output('dam_break_20120305_124724/dam_break.sww')
p2_st=util.get_centroids(p_st)

p_dev = util.get_output('dam_break_20130514_201704/dam_break.sww', 0.001)
p2_dev=util.get_centroids(p_dev, velocity_extrapolation=True)

pyplot.clf()
pyplot.ion()
pyplot.plot(p2_st.x, p2_st.stage[10,:],'r-', label='standard')
pyplot.plot(p2_st.x, p2_st.stage[50,:], 'r-')
pyplot.plot(p2_st.x, p2_st.stage[100,:], 'r-')

pyplot.plot(p2_dev.x, p2_dev.stage[10,:],'b-', label='devel')
pyplot.plot(p2_dev.x, p2_dev.stage[50,:],'b-')
pyplot.plot(p2_dev.x, p2_dev.stage[100,:],'b-')

pyplot.title('Stage at several instants in time')

pyplot.legend(loc=3)
pyplot.savefig('stage_plot.png')

pyplot.clf()
pyplot.ion()
pyplot.plot(p2_st.x, p2_st.xvel[10,:], 'r-', label='standard')
pyplot.plot(p2_st.x, p2_st.xvel[50,:], 'r-')
pyplot.plot(p2_st.x, p2_st.xvel[100,:],'r-')

pyplot.plot(p2_dev.x, p2_dev.xvel[10,:],'b-', label='devel')
pyplot.plot(p2_dev.x, p2_dev.xvel[50,:],'b-')
pyplot.plot(p2_dev.x, p2_dev.xvel[100,:],'b-')

pyplot.title('Velocity at several instants in time')

pyplot.legend(loc=2)
pyplot.savefig('xvel_plot.png')


